# PhasicFlow: rectangleMesh Class Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

rectangleMesh Class Reference
Inheritance diagram for rectangleMesh:
[legend]
Collaboration diagram for rectangleMesh:
[legend]

## Public Member Functions

| TypeInfo ("rectangleMesh")
| rectangleMesh (const box &mshBox, int32 nx, int32 ny, int32 nz, repository *rep)
| rectangleMesh (const dictionary &dict, repository *rep)
| rectangleMesh (const rectangleMesh &)=default
rectangleMesh & | operator= (const rectangleMesh &)=default
| rectangleMesh (rectangleMesh &&)=default
rectangleMesh & | operator= (rectangleMesh &&)=default
| ~rectangleMesh () override=default
int64 | size () const
int32 | nx () const
int32 | ny () const
int32 | nz () const
real | cellVol () const
realx3 | minPoint () const
realx3 | maxPoint () const
bool | isInsideIndex (const realx3 p, int32x3 &ind) const
bool | write (iOstream &is, const IOPattern &iop) const override
bool | read (iIstream &is, const IOPattern &iop) override
bool | writeToVtk (iOstream &os) const
Public Member Functions inherited from IOobject
virtual word | typeName () const =0
| IOobject (const objectFile &objf, const IOPattern &iop, repository *owner)
| ~IOobject () override
| IOobject (const IOobject &src)=delete
| IOobject (IOobject &&src)=delete
const IOPattern & | ioPattern () const
const repository * | owner () const override
repository * | owner ()
repository * | releaseOwner (bool fromOwner=false)
bool | isIncluded (const word &objName) const override
bool | isExcluded (const word &objName) const override
bool | readObject (bool rdHdr=true)
bool | writeObject () const
bool | readObject (iIstream &is, bool rdHdr=true)
bool | writeObject (iOstream &os) const
Public Member Functions inherited from IOfileHeader
| IOfileHeader (const objectFile &objf)
const word & | objectName () const
const word & | objectType () const
fileSystem | path () const
bool | outFileBinary () const
bool | inFileBinary () const
bool | headerOk (bool silent=false)
bool | implyRead () const
| Imply read. More...
bool | implyWrite () const
| Imply write. More...
bool | fileExist () const
| Check if file exists. More...
bool | readIfPresent () const
| Check read if present. More...
bool | writeHeader () const
| Check if the header should be written to file True: on master + implyWrite + readWriteHeader = true False: otherwise. More...
bool | writeHeader (iOstream &os, const word &typeName, bool forceWrite=false) const
| Write the header to the file , typeName comes from caller. More...
bool | writeHeader (iOstream &os, bool forceWrite=false) const
| Write the header to the file, typeName comes from the one read from file. More...
bool | readHeader () const
| Check if header should be read from file. More...
bool | readHeader (iIstream &is, bool silent=false)
| Read the header in the file. More...
bool | writeBanner (iOstream &os) const
| write the banner More...
bool | writeSeparator (iOstream &os) const
| wirte a separator line More...
Public Member Functions inherited from objectFile
| objectFile (const word &name)
| objectFile (const word &name, const fileSystem &localPath, const readFlag &rf=readFlag::READ_NEVER, const writeFlag &wf=writeFlag::WRITE_NEVER, bool rwHeader=true)
| objectFile (const objectFile &src)=default
| objectFile (objectFile &&src)=default
objectFile & | operator= (const objectFile &rhs)=default
objectFile & | operator= (objectFile &&rhs)=default
virtual | ~objectFile ()=default
virtual const word & | name () const
virtual const fileSystem & | localPath () const
readFlag | rFlag () const
writeFlag | wFlag () const
bool | isReadAlways () const
bool | isReadNever () const
bool | isReadIfPresent () const
bool | isWriteAlways () const
bool | isWriteNever () const
bool | readWriteHeader () const

## Private Attributes

box | meshBox_
int32x3 | numCells_
realx3 | dx_

## Additional Inherited Members

Public Types inherited from objectFile
enum | readFlag { READ_ALWAYS, READ_NEVER, READ_IF_PRESENT }
enum | writeFlag { WRITE_ALWAYS, WRITE_NEVER }
Protected Member Functions inherited from IOfileHeader
uniquePtr< iFstream > | inStream () const
uniquePtr< oFstream > | outStream () const
uniquePtr< oFstream > | dummyOutStream () const
Protected Attributes inherited from IOfileHeader
word | objectName_
word | objectType_
word | fileFormat_ = "ASCII"
| file format read from file More...

## Detailed Description

Definition at line 34 of file rectangleMesh.hpp.

## Constructor & Destructor Documentation

## rectangleMesh() [1/4]

rectangleMesh | ( | const box & | mshBox,
|  | int32 | nx,
|  | int32 | ny,
|  | int32 | nz,
|  | repository * | rep
| ) |  |

Definition at line 5 of file rectangleMesh.cpp.

References pFlow::endl(), fatalErrorInFunction, fatalExit, pFlow::algorithms::KOKKOS::max(), box::maxPoint(), and box::minPoint().

Here is the call graph for this function:

## rectangleMesh() [2/4]

rectangleMesh | ( | const dictionary & | dict,
|  | repository * | rep
| ) |  |

Definition at line 41 of file rectangleMesh.cpp.

## rectangleMesh() [3/4]

rectangleMesh | ( | const rectangleMesh & |  | ) |

default

## rectangleMesh() [4/4]

rectangleMesh | ( | rectangleMesh && |  | ) |

default

## ~rectangleMesh()

~rectangleMesh | ( |  | ) |

overridedefault

## Member Function Documentation

## TypeInfo()

TypeInfo | ( | "rectangleMesh" |  | ) |

## operator=() [1/2]

rectangleMesh& operator= | ( | const rectangleMesh & |  | ) |

default

## operator=() [2/2]

rectangleMesh& operator= | ( | rectangleMesh && |  | ) |

default

## size()

int64 size | ( |  | ) | const

inline

Definition at line 72 of file rectangleMesh.hpp.

References rectangleMesh::numCells_, triple< T >::x_, triple< T >::y_, and triple< T >::z_.

Referenced by rectMeshField< int32 >::size().

Here is the caller graph for this function:

## nx()

int32 nx | ( |  | ) | const

inline

Definition at line 77 of file rectangleMesh.hpp.

References rectangleMesh::numCells_, and triple< T >::x().

Referenced by cellMapper::allocateArrays(), pointRectCell::mapPOints(), rectMeshField< int32 >::nx(), and rectangleMesh::writeToVtk().

Here is the call graph for this function:
Here is the caller graph for this function:

## ny()

int32 ny | ( |  | ) | const

inline

Definition at line 82 of file rectangleMesh.hpp.

References rectangleMesh::numCells_, and triple< T >::y().

Referenced by cellMapper::allocateArrays(), pointRectCell::mapPOints(), rectMeshField< int32 >::ny(), and rectangleMesh::writeToVtk().

Here is the call graph for this function:
Here is the caller graph for this function:

## nz()

int32 nz | ( |  | ) | const

inline

Definition at line 87 of file rectangleMesh.hpp.

References rectangleMesh::numCells_, and triple< T >::z().

Referenced by cellMapper::allocateArrays(), pointRectCell::mapPOints(), rectMeshField< int32 >::nz(), and rectangleMesh::writeToVtk().

Here is the call graph for this function:
Here is the caller graph for this function:

## cellVol()

real cellVol | ( |  | ) | const

inline

Definition at line 92 of file rectangleMesh.hpp.

References rectangleMesh::dx_, triple< T >::x_, triple< T >::y_, and triple< T >::z_.

Referenced by rectMeshField< int32 >::cellVol().

Here is the caller graph for this function:

## minPoint()

realx3 minPoint | ( |  | ) | const

inline

Definition at line 97 of file rectangleMesh.hpp.

References rectangleMesh::meshBox_, and box::minPoint().

Referenced by rectangleMesh::writeToVtk().

Here is the call graph for this function:
Here is the caller graph for this function:

## maxPoint()

realx3 maxPoint | ( |  | ) | const

inline

Definition at line 102 of file rectangleMesh.hpp.

References box::maxPoint(), and rectangleMesh::meshBox_.

Here is the call graph for this function:

## isInsideIndex()

bool isInsideIndex | ( | const realx3 | p,
|  | int32x3 & | ind
| ) |  | const

inline

Definition at line 108 of file rectangleMesh.hpp.

References rectangleMesh::dx_, box::isInside(), rectangleMesh::meshBox_, and box::minPoint().

Here is the call graph for this function:

## write()

bool write | ( | iOstream & | is,
|  | const IOPattern & | iop
| ) |  | const

inlineoverridevirtual

Implements IOobject.

Definition at line 121 of file rectangleMesh.hpp.

References notImplementedFunction.

## read()

bool read | ( | iIstream & | is,
|  | const IOPattern & | iop
| ) |  |

inlineoverridevirtual

Implements IOobject.

Definition at line 127 of file rectangleMesh.hpp.

References notImplementedFunction.

## writeToVtk()

bool writeToVtk | ( | iOstream & | os | ) | const

inline

Definition at line 133 of file rectangleMesh.hpp.

References rectangleMesh::dx_, pFlow::endl(), rectangleMesh::minPoint(), rectangleMesh::nx(), rectangleMesh::ny(), and rectangleMesh::nz().

Here is the call graph for this function:

## Member Data Documentation

## meshBox_

box meshBox_

private

Definition at line 40 of file rectangleMesh.hpp.

Referenced by rectangleMesh::isInsideIndex(), rectangleMesh::maxPoint(), and rectangleMesh::minPoint().

## numCells_

int32x3 numCells_

private

Definition at line 42 of file rectangleMesh.hpp.

Referenced by rectangleMesh::nx(), rectangleMesh::ny(), rectangleMesh::nz(), and rectangleMesh::size().

## dx_

realx3 dx_

private

Definition at line 44 of file rectangleMesh.hpp.

Referenced by rectangleMesh::cellVol(), rectangleMesh::isInsideIndex(), and rectangleMesh::writeToVtk().

The documentation for this class was generated from the following files:

- utilities/postprocessPhasicFlow/rectangleMesh.hpp
- utilities/postprocessPhasicFlow/rectangleMesh.cpp